<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Crypto::Sha256 Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/dad/classThread_1_1Crypto_1_1Sha256.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../dc/de4/classThread_1_1Crypto_1_1Sha256-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Crypto::Sha256 Class Reference<div class="ingroups"><a class="el" href="../../d0/de1/group__core.html">Core</a> &raquo; <a class="el" href="../../dd/dcf/group__core-security.html">Security</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements SHA-256 computation.  
 <a href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d5/d68/sha256_8hpp_source.html">src/core/crypto/sha256.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a4dfb289559b3d1287ad7bf78c47d64fa"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom">{ <a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a4dfb289559b3d1287ad7bf78c47d64faa4ee551b7d48214f58b3027da0019dca0">kHashSize</a> = 32
 }</td></tr>
<tr class="separator:a4dfb289559b3d1287ad7bf78c47d64fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1669230129da388c39957d064e56cd91"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1669230129da388c39957d064e56cd91"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a1669230129da388c39957d064e56cd91">Start</a> (void)</td></tr>
<tr class="memdesc:a1669230129da388c39957d064e56cd91"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method starts the SHA-256 computation. <br /></td></tr>
<tr class="separator:a1669230129da388c39957d064e56cd91"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab73cec68935d6ea376a717350fbe82e5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#ab73cec68935d6ea376a717350fbe82e5">Update</a> (const uint8_t *aBuf, uint16_t aBufLength)</td></tr>
<tr class="memdesc:ab73cec68935d6ea376a717350fbe82e5"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method inputs bytes into the SHA-256 computation.  <a href="#ab73cec68935d6ea376a717350fbe82e5">More...</a><br /></td></tr>
<tr class="separator:ab73cec68935d6ea376a717350fbe82e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b5e941ab243292a8ca7a63dc012a733"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a1b5e941ab243292a8ca7a63dc012a733">Finish</a> (uint8_t aHash[<a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a4dfb289559b3d1287ad7bf78c47d64faa4ee551b7d48214f58b3027da0019dca0">kHashSize</a>])</td></tr>
<tr class="memdesc:a1b5e941ab243292a8ca7a63dc012a733"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method finalizes the hash computation.  <a href="#a1b5e941ab243292a8ca7a63dc012a733">More...</a><br /></td></tr>
<tr class="separator:a1b5e941ab243292a8ca7a63dc012a733"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements SHA-256 computation. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a class="anchor" id="a4dfb289559b3d1287ad7bf78c47d64fa"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anonymous enum</td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a class="anchor" id="a4dfb289559b3d1287ad7bf78c47d64faa4ee551b7d48214f58b3027da0019dca0"></a>kHashSize&#160;</td><td class="fielddoc">
<p>SHA-256 hash size (bytes) </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a1b5e941ab243292a8ca7a63dc012a733"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::Sha256::Finish </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aHash</em>[kHashSize]</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method finalizes the hash computation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">aHash</td><td>A pointer to the output buffer. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/dad/classThread_1_1Crypto_1_1Sha256_a1b5e941ab243292a8ca7a63dc012a733_icgraph.png" border="0" usemap="#d0/dad/classThread_1_1Crypto_1_1Sha256_a1b5e941ab243292a8ca7a63dc012a733_icgraph" alt=""/></div>
<map name="d0/dad/classThread_1_1Crypto_1_1Sha256_a1b5e941ab243292a8ca7a63dc012a733_icgraph" id="d0/dad/classThread_1_1Crypto_1_1Sha256_a1b5e941ab243292a8ca7a63dc012a733_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aae0b5815d71f1391216725ee8ba14e34" title="This method gets the Hash Mac Address. " alt="" coords="225,68,414,107"/>
<area shape="rect" id="node7" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a6ab4602c1046d668aaba6dfcafe59cfa" title="This method provides a received DTLS message to the DTLS object. " alt="" coords="239,131,399,169"/>
<area shape="rect" id="node8" href="../../dd/d32/classThread_1_1Utils_1_1SemanticallyOpaqueIidGenerator.html#aa63452c20829bd917ecdbe0448bacab8" title="This function creates semantically opaque IID for given IPv6 address and context. ..." alt="" coords="217,193,421,232"/>
<area shape="rect" id="node3" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="469,5,643,44"/>
<area shape="rect" id="node4" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a5109c8ea0e2c168c18f729d767e6b999" title="This method stops the Joiner service. " alt="" coords="469,68,643,107"/>
<area shape="rect" id="node5" href="../../df/d4f/group__config-general.html#gab5c459f62f9f6ca104fe953fa271a82a" title="Get the Hash Mac Address. " alt="" coords="476,131,636,156"/>
<area shape="rect" id="node6" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="691,124,846,163"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ab73cec68935d6ea376a717350fbe82e5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::Sha256::Update </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aBufLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method inputs bytes into the SHA-256 computation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuf</td><td>A pointer to the input buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aBufLength</td><td>The length of <code>aBuf</code> in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/dad/classThread_1_1Crypto_1_1Sha256_ab73cec68935d6ea376a717350fbe82e5_icgraph.png" border="0" usemap="#d0/dad/classThread_1_1Crypto_1_1Sha256_ab73cec68935d6ea376a717350fbe82e5_icgraph" alt=""/></div>
<map name="d0/dad/classThread_1_1Crypto_1_1Sha256_ab73cec68935d6ea376a717350fbe82e5_icgraph" id="d0/dad/classThread_1_1Crypto_1_1Sha256_ab73cec68935d6ea376a717350fbe82e5_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aae0b5815d71f1391216725ee8ba14e34" title="This method gets the Hash Mac Address. " alt="" coords="225,68,414,107"/>
<area shape="rect" id="node7" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a6ab4602c1046d668aaba6dfcafe59cfa" title="This method provides a received DTLS message to the DTLS object. " alt="" coords="239,131,399,169"/>
<area shape="rect" id="node8" href="../../dd/d32/classThread_1_1Utils_1_1SemanticallyOpaqueIidGenerator.html#aa63452c20829bd917ecdbe0448bacab8" title="This function creates semantically opaque IID for given IPv6 address and context. ..." alt="" coords="217,193,421,232"/>
<area shape="rect" id="node3" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="469,5,643,44"/>
<area shape="rect" id="node4" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a5109c8ea0e2c168c18f729d767e6b999" title="This method stops the Joiner service. " alt="" coords="469,68,643,107"/>
<area shape="rect" id="node5" href="../../df/d4f/group__config-general.html#gab5c459f62f9f6ca104fe953fa271a82a" title="Get the Hash Mac Address. " alt="" coords="476,131,636,156"/>
<area shape="rect" id="node6" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="691,124,846,163"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/core/crypto/<a class="el" href="../../d5/d68/sha256_8hpp_source.html">sha256.hpp</a></li>
<li>src/core/crypto/<a class="el" href="../../d4/d08/sha256_8cpp.html">sha256.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><b>Crypto</b></li><li class="navelem"><a class="el" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html">Sha256</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
